import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

public class Task7 {
	public static FastReader in = new FastReader();
	public static void main(String[] args) {
		int n = in.nextInt();
		int m = in.nextInt();
		int[] p = new int[n];
		p[0] = -1;
		HashMap<Integer,ArrayList<Integer>> sons = new HashMap<Integer,ArrayList<Integer>>();
		for(int i = 1 ; i < n ; i++) {
			int a = in.nextInt() -1;
			p[i] = a;
			if(!sons.containsKey(a)) sons.put(a, new ArrayList<Integer>());
			sons.get(a).add(i);
		}
		int c[] = new int[n];
		for(int i = 1 ; i < n ; i++) {
			c[p[i]]++;
		}
		int key[] = new int[n];
		PriorityQueue<Integer> queue = new PriorityQueue<Integer>();
		for(int i = 1 ; i < n ; i++) {
			if(c[i] == 0 && key[p[i]] == 0) {
				key[p[i]] = 1;
				queue.add(p[i]);
			}
		}
		
		while(!queue.isEmpty()) {
			int i = queue.poll();
			if(i == 0) continue;
			int s = key[p[i]];
			key[p[i]] = Math.max(key[p[i]], key[i] + 1);
			if(p[i] != 0 && s != key[p[i]]) queue.add(p[i]);
		}
		int maxId = -1;
		int max = -1;
		for(int i = 0 ; i < n ; i++) {
			ArrayList<Integer> temp = sons.get(i);
			if(temp != null && temp.size() > 1) {
				int s = getMax(temp, key);
				if(s >= max) {
					max = s;
					maxId = i;
				}
			}
		}
		key[0]++;
		max+=3;
		
		if(maxId == -1) {
			long ans = ((long)key[0])*m;
			System.out.print(ans);
		}
		else {
			if(m == 1) {
				long ans = ((long)Math.max(key[0], max));
				System.out.print(ans); 
			}
			else {
				long ans = ((long)max) + 2l*(long)(m-1)*(long)key[0];
				System.out.print(ans);
			}
		}
		
	}
	
	public static int getMax(ArrayList<Integer> temp, int[] key) {
		int max1 = -1;
		int max2 = -1;
		for(int i : temp) {
			if(max1 == -1 ) max1 = i;
			else {
				if(key[max1] < key[i]) {
					max2 = max1;
					max1 = i;
				}else if(max2 == -1 || key[max2] < key[i]) max2 = i;
			}
		}
		return key[max1] + key[max2];
	}
	
	static class FastReader {
		BufferedReader br;
		StringTokenizer st;
		
		FastReader() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}
		
		String next() {
			while(st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				}catch(Exception e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		
		int nextInt() {
			return Integer.parseInt(next());
		}
	}
}
