import java.util.ArrayList;
import java.util.HashMap;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Task7 {
	public static Scanner in = new Scanner(System.in);
	public static void main(String[] args) {
		int n = in.nextInt();
		int m = in.nextInt();
		int[] p = new int[n];
		p[0] = -1;
		HashMap<Integer,ArrayList<Integer>> sons = new HashMap<Integer,ArrayList<Integer>>();
		for(int i = 0 ; i < n ; i++) {
			sons.put(i, new ArrayList<Integer>());
		}
		for(int i = 1 ; i < n ; i++) {
			int a = in.nextInt() -1;
			p[i] = a;
			sons.get(a).add(i);
		}
		int c[] = new int[n];
		for(int i = 1 ; i < n ; i++) {
			c[p[i]]++;
		}
		int key[] = new int[n];
		PriorityQueue<Integer> queue = new PriorityQueue<Integer>();
		for(int i = 1 ; i < n ; i++) {
			if(c[i] == 0 && key[p[i]] == 0) {
				key[p[i]] = 1;
				if(!queue.contains(p[i]))queue.add(p[i]);
			}
		}
		
		while(!queue.isEmpty()) {
			int i = queue.poll();
			if(i == 0) continue;
			key[p[i]] = Math.max(key[p[i]], key[i] + 1);
			if(p[i] != 0) queue.add(p[i]);
		}
		int maxId = -1;
		int max = 1;
		for(int i = 0 ; i < n ; i++) {
			ArrayList<Integer> temp = sons.get(i);
			if(temp.size() > 1) {
				int s = getMax(temp, key);
				//System.out.print(s);
				if(s >= max) {
					max = s;
					maxId = i;
				}
			}
		}
		key[0]++;
		max+=3;
		//System.out.println(key[0] + " " + key[0]);
		//System.out.println(maxId + " " + max); 
		if(maxId == -1) System.out.print(key[0]*m);
		else {
			//System.out.print(max);
			if(m == 1) System.out.print(Math.max(key[0], max)); 
			else System.out.print(max + 2*(m-1)*key[0]);
		}
		
	}
	
	public static int getMax(ArrayList<Integer> temp, int[] key) {
		int max1 = temp.get(0);
		int max2 = temp.get(1);
		for(int i : temp) {
			if(key[i] >= key[max1]) max1 = i;
		}
		if(max2 == max1) max2 = temp.get(0);
		for(int i : temp) {
			if(key[i] >= key[max2] && i != max1) max2 = i;
		}
		return key[max1] + key[max2];
	}
}
